"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var isValidPath = require("is-valid-path");
var fs_1 = require("fs");
var path_1 = require("path");
var schema_1 = require("../loaders/schema");
var documents_1 = require("../loaders/documents");
var render_1 = require("../render");
var coverage_1 = require("../../coverage");
var fs_2 = require("../../utils/fs");
var json_1 = require("../../coverage/output/json");
function coverage(documentsPointer, schemaPointer, options) {
    return __awaiter(this, void 0, void 0, function () {
        var renderer, silent, writePath, shouldWrite, schema, documents, coverage_2, absPath, ext, output, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    renderer = options.renderer || new render_1.ConsoleRenderer();
                    silent = options.silent === true;
                    writePath = options.write;
                    shouldWrite = typeof writePath !== 'undefined';
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, schema_1.loadSchema(schemaPointer)];
                case 2:
                    schema = _a.sent();
                    return [4 /*yield*/, documents_1.loadDocuments(documentsPointer)];
                case 3:
                    documents = _a.sent();
                    coverage_2 = coverage_1.coverage(schema, documents);
                    if (!silent) {
                        renderer.coverage(coverage_2);
                    }
                    if (shouldWrite) {
                        if (typeof writePath !== 'string' || !isValidPath(writePath)) {
                            throw new Error("--write is not valid file path: " + writePath);
                        }
                        absPath = fs_2.ensureAbsolute(writePath);
                        ext = path_1.extname(absPath)
                            .replace('.', '')
                            .toLocaleLowerCase();
                        output = undefined;
                        if (ext === 'json') {
                            output = json_1.outputJSON(coverage_2);
                        }
                        if (output) {
                            fs_1.writeFileSync(absPath, json_1.outputJSON(coverage_2), {
                                encoding: 'utf-8',
                            });
                            renderer.success('Available at', absPath, '\n');
                        }
                        else {
                            throw new Error("Extension " + ext + " is not supported");
                        }
                    }
                    return [3 /*break*/, 5];
                case 4:
                    e_1 = _a.sent();
                    console.log(e_1);
                    renderer.error(e_1);
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5:
                    process.exit(0);
                    return [2 /*return*/];
            }
        });
    });
}
exports.coverage = coverage;
//# sourceMappingURL=coverage.js.map