"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var isValidPath = require("is-valid-path");
var fs_1 = require("../../utils/fs");
function pipe() {
    var middlewares = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        middlewares[_i] = arguments[_i];
    }
    return function (value) {
        return middlewares.reduce(function (val, fn) { return fn(val); }, value);
    };
}
exports.pipe = pipe;
function useRequire(options) {
    if (options.require) {
        options.require.forEach(function (mod) {
            return require(isValidPath(mod) ? fs_1.ensureAbsolute(mod) : mod);
        });
    }
    return options;
}
exports.useRequire = useRequire;
function normalizeRequire(options) {
    if (typeof options.parent.require === 'undefined') {
        return __assign({}, options, { require: [] });
    }
    var normalized = Array.isArray(options.parent.require)
        ? options.parent.require
        : [options.parent.require];
    return __assign({}, options, { require: normalized });
}
function normalizeOptions(options) {
    return pipe(normalizeRequire, useRequire)(options);
}
exports.normalizeOptions = normalizeOptions;
//# sourceMappingURL=options.js.map